var developerConsole = require('letsnet-developerconsole')()
console.developer = developerConsole.developerConsole

var mongoose = require('mongoose')
const fs = require('fs')
var Queue = require('./queue')

var API = function(defaults) {
  mongodb = null
  mongooseCredentials = null
  this.openSchema = null
  queue = null
  this.middlewares = {}
  this.dataSchemas = {}
}

API.prototype.addMiddleware = function(name, func) {
  this.middlewares[name] = func
}

API.prototype.mongoConnect = function() {
  if(this.mongooseCredentials == null) throw 'Please set mongooseCredentials with setMongooseCredentials(object) function ...'
  else this.mongodb = mongoose.createConnection('mongodb://' + this.mongooseCredentials.user + ':' + this.mongooseCredentials.passwd + this.mongooseCredentials.url)
}

API.prototype.mongoClose = function() {
  mongoose.disconnect()
  this.mongodb = null
}

API.prototype.setMongooseCredentials = function(object) {
  if(object.user === 'undefined' || object.user == null) throw 'You must define the \'USER\' of the connection!'
  else if(object.url === 'undefined' || object.url == null) throw 'You must define the \'URL\' of the connection!'
  else if(object.passwd === 'undefined' || object.passwd == null) throw 'You must define the \'PASSWORD\' of the connection!'
  else { this.mongooseCredentials = object }
}

API.prototype.closeMongooseCredentials = function(object) {
  this.mongooseCredentials = null
}

API.prototype.createSchema = function(database, object) {
  if(this.mongodb == null) throw 'Please set a connection with mongoConnect function!'
  else this.openSchema = this.mongodb.model(database, new mongoose.Schema(object))
}

API.prototype.closeSchema = function() {
  this.schema = null
}

API.prototype.addFunction = function(defs, rFunction) {
  if(rFunction instanceof Function) {
    this[defs.name] = function() {
      this.queue = new Queue(arguments)
      this.queue.setMasterFunction(defs.schema, rFunction)
      this.queue.next()
    }
  }
  else new Error('The second parameter must be a function!')
}

module.exports = API